package dev.shadowsoffire.apotheosis.spawn.enchantment;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import dev.shadowsoffire.apotheosis.spawn.SpawnerModule;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.SpawnEggItem;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.common.ForgeSpawnEggItem;
import net.minecraftforge.event.entity.living.LivingDropsEvent;

public class CapturingEnchant extends Enchantment {
  public CapturingEnchant() {
    super(Enchantment.Rarity.VERY_RARE, EnchantmentCategory.WEAPON, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
  }
  
  public int m_6586_() {
    return 5;
  }
  
  public int m_6183_(int level) {
    return 28 + (level - 1) * 15;
  }
  
  public int m_6175_(int level) {
    return m_6183_(level) + 15;
  }
  
  public boolean canApplyAtEnchantingTable(ItemStack stack) {
    return (super.canApplyAtEnchantingTable(stack) || EnchModule.AXE.m_7454_(stack.m_41720_()));
  }
  
  public void handleCapturing(LivingDropsEvent e) {
    Entity killer = e.getSource().m_7639_();
    if (killer instanceof LivingEntity) {
      LivingEntity living = (LivingEntity)killer;
      int level = living.m_21205_().getEnchantmentLevel((Enchantment)Apoth.Enchantments.CAPTURING.get());
      LivingEntity killed = e.getEntity();
      if (SpawnerModule.bannedMobs.contains(EntityType.m_20613_(killed.m_6095_())))
        return; 
      if ((killed.m_9236_()).f_46441_.m_188501_() < level / 250.0F) {
        SpawnEggItem spawnEggItem = ForgeSpawnEggItem.fromEntityType(killed.m_6095_());
        if (spawnEggItem == null)
          return; 
        ItemStack egg = new ItemStack((ItemLike)spawnEggItem);
        e.getDrops().add(new ItemEntity(killed.m_9236_(), killed.m_20185_(), killed.m_20186_(), killed.m_20189_(), egg));
      } 
    } 
  }
}
